=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpAnsibleClient
  class ApiCollectionsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # View for Collection models.
    # @param ansible_collection_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedGalaxyCollectionResponseList]
    def get(ansible_collection_href, opts = {})
      data, _status_code, _headers = get_with_http_info(ansible_collection_href, opts)
      data
    end

    # View for Collection models.
    # @param ansible_collection_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedGalaxyCollectionResponseList, Integer, Hash)>] PaginatedGalaxyCollectionResponseList data, response status code and response headers
    def get_with_http_info(ansible_collection_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ApiCollectionsApi.get ...'
      end
      # verify the required parameter 'ansible_collection_href' is set
      if @api_client.config.client_side_validation && ansible_collection_href.nil?
        fail ArgumentError, "Missing the required parameter 'ansible_collection_href' when calling ApiCollectionsApi.get"
      end
      # resource path
      local_var_path = '{ansible_collection_href}api/v2/collections/'.sub('{' + 'ansible_collection_href' + '}', CGI.escape(ansible_collection_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedGalaxyCollectionResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ApiCollectionsApi#get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Queues a task that creates a new Collection from an uploaded artifact.
    # @param ansible_collection_href [String] 
    # @param galaxy_collection [GalaxyCollection] 
    # @param [Hash] opts the optional parameters
    # @return [GalaxyCollectionResponse]
    def post(ansible_collection_href, galaxy_collection, opts = {})
      data, _status_code, _headers = post_with_http_info(ansible_collection_href, galaxy_collection, opts)
      data
    end

    # Queues a task that creates a new Collection from an uploaded artifact.
    # @param ansible_collection_href [String] 
    # @param galaxy_collection [GalaxyCollection] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(GalaxyCollectionResponse, Integer, Hash)>] GalaxyCollectionResponse data, response status code and response headers
    def post_with_http_info(ansible_collection_href, galaxy_collection, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ApiCollectionsApi.post ...'
      end
      # verify the required parameter 'ansible_collection_href' is set
      if @api_client.config.client_side_validation && ansible_collection_href.nil?
        fail ArgumentError, "Missing the required parameter 'ansible_collection_href' when calling ApiCollectionsApi.post"
      end
      # verify the required parameter 'galaxy_collection' is set
      if @api_client.config.client_side_validation && galaxy_collection.nil?
        fail ArgumentError, "Missing the required parameter 'galaxy_collection' when calling ApiCollectionsApi.post"
      end
      # resource path
      local_var_path = '{ansible_collection_href}api/v2/collections/'.sub('{' + 'ansible_collection_href' + '}', CGI.escape(ansible_collection_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(galaxy_collection) 

      # return_type
      return_type = opts[:return_type] || 'GalaxyCollectionResponse' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ApiCollectionsApi#post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
