=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpAnsibleClient
  class CollectionImportApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Inspect a collection import
    # Returns a CollectionImport object.
    # @param ansible_collection_import_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :since Filter messages since a given timestamp
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [CollectionImportDetailResponse]
    def read(ansible_collection_import_href, opts = {})
      data, _status_code, _headers = read_with_http_info(ansible_collection_import_href, opts)
      data
    end

    # Inspect a collection import
    # Returns a CollectionImport object.
    # @param ansible_collection_import_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :since Filter messages since a given timestamp
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(CollectionImportDetailResponse, Integer, Hash)>] CollectionImportDetailResponse data, response status code and response headers
    def read_with_http_info(ansible_collection_import_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CollectionImportApi.read ...'
      end
      # verify the required parameter 'ansible_collection_import_href' is set
      if @api_client.config.client_side_validation && ansible_collection_import_href.nil?
        fail ArgumentError, "Missing the required parameter 'ansible_collection_import_href' when calling CollectionImportApi.read"
      end
      # resource path
      local_var_path = '{ansible_collection_import_href}'.sub('{' + 'ansible_collection_import_href' + '}', CGI.escape(ansible_collection_import_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'since'] = opts[:'since'] if !opts[:'since'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'CollectionImportDetailResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CollectionImportApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
