=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpAnsibleClient
  class ContentCollectionSignaturesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a collection version signature
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param file [File] An uploaded file that may be turned into the artifact of the content unit.
    # @param signed_collection [String] The content this signature is pointing to.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @return [AsyncOperationResponse]
    def create(file, signed_collection, opts = {})
      data, _status_code, _headers = create_with_http_info(file, signed_collection, opts)
      data
    end

    # Create a collection version signature
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param file [File] An uploaded file that may be turned into the artifact of the content unit.
    # @param signed_collection [String] The content this signature is pointing to.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(file, signed_collection, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentCollectionSignaturesApi.create ...'
      end
      # verify the required parameter 'file' is set
      if @api_client.config.client_side_validation && file.nil?
        fail ArgumentError, "Missing the required parameter 'file' when calling ContentCollectionSignaturesApi.create"
      end
      # verify the required parameter 'signed_collection' is set
      if @api_client.config.client_side_validation && signed_collection.nil?
        fail ArgumentError, "Missing the required parameter 'signed_collection' when calling ContentCollectionSignaturesApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/ansible/collection_signatures/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['multipart/form-data', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}
      form_params['file'] = file
      form_params['signed_collection'] = signed_collection
      form_params['repository'] = opts[:'repository'] if !opts[:'repository'].nil?

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentCollectionSignaturesApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List collection version signatures
    # ViewSet for looking at signature objects for CollectionVersion content.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pubkey_fingerprint Filter results where pubkey_fingerprint matches value
    # @option opts [Array<String>] :pubkey_fingerprint__in Filter results where pubkey_fingerprint is in a comma-separated list of values
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :signed_collection Filter signatures for collection version
    # @option opts [String] :signing_service Filter signatures produced by signature service
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedansibleCollectionVersionSignatureResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List collection version signatures
    # ViewSet for looking at signature objects for CollectionVersion content.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pubkey_fingerprint Filter results where pubkey_fingerprint matches value
    # @option opts [Array<String>] :pubkey_fingerprint__in Filter results where pubkey_fingerprint is in a comma-separated list of values
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :signed_collection Filter signatures for collection version
    # @option opts [String] :signing_service Filter signatures produced by signature service
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedansibleCollectionVersionSignatureResponseList, Integer, Hash)>] PaginatedansibleCollectionVersionSignatureResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentCollectionSignaturesApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/ansible/collection_signatures/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'pubkey_fingerprint'] = opts[:'pubkey_fingerprint'] if !opts[:'pubkey_fingerprint'].nil?
      query_params[:'pubkey_fingerprint__in'] = @api_client.build_collection_param(opts[:'pubkey_fingerprint__in'], :csv) if !opts[:'pubkey_fingerprint__in'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'signed_collection'] = opts[:'signed_collection'] if !opts[:'signed_collection'].nil?
      query_params[:'signing_service'] = opts[:'signing_service'] if !opts[:'signing_service'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedansibleCollectionVersionSignatureResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentCollectionSignaturesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a collection version signature
    # ViewSet for looking at signature objects for CollectionVersion content.
    # @param ansible_collection_version_signature_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [AnsibleCollectionVersionSignatureResponse]
    def read(ansible_collection_version_signature_href, opts = {})
      data, _status_code, _headers = read_with_http_info(ansible_collection_version_signature_href, opts)
      data
    end

    # Inspect a collection version signature
    # ViewSet for looking at signature objects for CollectionVersion content.
    # @param ansible_collection_version_signature_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(AnsibleCollectionVersionSignatureResponse, Integer, Hash)>] AnsibleCollectionVersionSignatureResponse data, response status code and response headers
    def read_with_http_info(ansible_collection_version_signature_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentCollectionSignaturesApi.read ...'
      end
      # verify the required parameter 'ansible_collection_version_signature_href' is set
      if @api_client.config.client_side_validation && ansible_collection_version_signature_href.nil?
        fail ArgumentError, "Missing the required parameter 'ansible_collection_version_signature_href' when calling ContentCollectionSignaturesApi.read"
      end
      # resource path
      local_var_path = '{ansible_collection_version_signature_href}'.sub('{' + 'ansible_collection_version_signature_href' + '}', CGI.escape(ansible_collection_version_signature_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AnsibleCollectionVersionSignatureResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentCollectionSignaturesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
