=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpAnsibleClient
  class PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsArtifactsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Collection download endpoint.
    # @param distro_base_path [String] 
    # @param filename [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [nil]
    def download(distro_base_path, filename, opts = {})
      download_with_http_info(distro_base_path, filename, opts)
      nil
    end

    # Collection download endpoint.
    # @param distro_base_path [String] 
    # @param filename [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def download_with_http_info(distro_base_path, filename, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsArtifactsApi.download ...'
      end
      # verify the required parameter 'distro_base_path' is set
      if @api_client.config.client_side_validation && distro_base_path.nil?
        fail ArgumentError, "Missing the required parameter 'distro_base_path' when calling PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsArtifactsApi.download"
      end
      # verify the required parameter 'filename' is set
      if @api_client.config.client_side_validation && filename.nil?
        fail ArgumentError, "Missing the required parameter 'filename' when calling PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsArtifactsApi.download"
      end
      # resource path
      local_var_path = '/pulp_ansible/galaxy/default/api/v3/plugin/ansible/content/{distro_base_path}/collections/artifacts/{filename}'.sub('{' + 'distro_base_path' + '}', CGI.escape(distro_base_path.to_s).gsub('%2F', '/')).sub('{' + 'filename' + '}', CGI.escape(filename.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsArtifactsApi#download\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
