=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpAnsibleClient
  class PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Trigger an asynchronous delete task
    # @param distro_base_path [String] 
    # @param name [String] 
    # @param namespace [String] 
    # @param version [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(distro_base_path, name, namespace, version, opts = {})
      data, _status_code, _headers = delete_with_http_info(distro_base_path, name, namespace, version, opts)
      data
    end

    # Trigger an asynchronous delete task
    # @param distro_base_path [String] 
    # @param name [String] 
    # @param namespace [String] 
    # @param version [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(distro_base_path, name, namespace, version, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi.delete ...'
      end
      # verify the required parameter 'distro_base_path' is set
      if @api_client.config.client_side_validation && distro_base_path.nil?
        fail ArgumentError, "Missing the required parameter 'distro_base_path' when calling PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi.delete"
      end
      # verify the required parameter 'name' is set
      if @api_client.config.client_side_validation && name.nil?
        fail ArgumentError, "Missing the required parameter 'name' when calling PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi.delete"
      end
      # verify the required parameter 'namespace' is set
      if @api_client.config.client_side_validation && namespace.nil?
        fail ArgumentError, "Missing the required parameter 'namespace' when calling PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi.delete"
      end
      # verify the required parameter 'version' is set
      if @api_client.config.client_side_validation && version.nil?
        fail ArgumentError, "Missing the required parameter 'version' when calling PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi.delete"
      end
      # resource path
      local_var_path = '/pulp_ansible/galaxy/default/api/v3/plugin/ansible/content/{distro_base_path}/collections/index/{namespace}/{name}/versions/{version}/'.sub('{' + 'distro_base_path' + '}', CGI.escape(distro_base_path.to_s).gsub('%2F', '/')).sub('{' + 'name' + '}', CGI.escape(name.to_s).gsub('%2F', '/')).sub('{' + 'namespace' + '}', CGI.escape(namespace.to_s).gsub('%2F', '/')).sub('{' + 'version' + '}', CGI.escape(version.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns paginated CollectionVersions list.
    # @param distro_base_path [String] 
    # @param name [String] 
    # @param namespace [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :is_highest 
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name2 
    # @option opts [String] :namespace2 
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :q 
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :tags Filter by comma separate list of tags that must all be matched
    # @option opts [String] :version Filter results where version matches value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedCollectionVersionListResponseList]
    def list(distro_base_path, name, namespace, opts = {})
      data, _status_code, _headers = list_with_http_info(distro_base_path, name, namespace, opts)
      data
    end

    # Returns paginated CollectionVersions list.
    # @param distro_base_path [String] 
    # @param name [String] 
    # @param namespace [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :is_highest 
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name2 
    # @option opts [String] :namespace2 
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :q 
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :tags Filter by comma separate list of tags that must all be matched
    # @option opts [String] :version Filter results where version matches value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedCollectionVersionListResponseList, Integer, Hash)>] PaginatedCollectionVersionListResponseList data, response status code and response headers
    def list_with_http_info(distro_base_path, name, namespace, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi.list ...'
      end
      # verify the required parameter 'distro_base_path' is set
      if @api_client.config.client_side_validation && distro_base_path.nil?
        fail ArgumentError, "Missing the required parameter 'distro_base_path' when calling PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi.list"
      end
      # verify the required parameter 'name' is set
      if @api_client.config.client_side_validation && name.nil?
        fail ArgumentError, "Missing the required parameter 'name' when calling PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi.list"
      end
      # verify the required parameter 'namespace' is set
      if @api_client.config.client_side_validation && namespace.nil?
        fail ArgumentError, "Missing the required parameter 'namespace' when calling PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi.list"
      end
      # resource path
      local_var_path = '/pulp_ansible/galaxy/default/api/v3/plugin/ansible/content/{distro_base_path}/collections/index/{namespace}/{name}/versions/'.sub('{' + 'distro_base_path' + '}', CGI.escape(distro_base_path.to_s).gsub('%2F', '/')).sub('{' + 'name' + '}', CGI.escape(name.to_s).gsub('%2F', '/')).sub('{' + 'namespace' + '}', CGI.escape(namespace.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'is_highest'] = opts[:'is_highest'] if !opts[:'is_highest'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name2'] if !opts[:'name2'].nil?
      query_params[:'namespace'] = opts[:'namespace2'] if !opts[:'namespace2'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'tags'] = opts[:'tags'] if !opts[:'tags'].nil?
      query_params[:'version'] = opts[:'version'] if !opts[:'version'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedCollectionVersionListResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns a CollectionVersion object.
    # @param distro_base_path [String] 
    # @param name [String] 
    # @param namespace [String] 
    # @param version [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [CollectionVersionResponse]
    def read(distro_base_path, name, namespace, version, opts = {})
      data, _status_code, _headers = read_with_http_info(distro_base_path, name, namespace, version, opts)
      data
    end

    # Returns a CollectionVersion object.
    # @param distro_base_path [String] 
    # @param name [String] 
    # @param namespace [String] 
    # @param version [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(CollectionVersionResponse, Integer, Hash)>] CollectionVersionResponse data, response status code and response headers
    def read_with_http_info(distro_base_path, name, namespace, version, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi.read ...'
      end
      # verify the required parameter 'distro_base_path' is set
      if @api_client.config.client_side_validation && distro_base_path.nil?
        fail ArgumentError, "Missing the required parameter 'distro_base_path' when calling PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi.read"
      end
      # verify the required parameter 'name' is set
      if @api_client.config.client_side_validation && name.nil?
        fail ArgumentError, "Missing the required parameter 'name' when calling PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi.read"
      end
      # verify the required parameter 'namespace' is set
      if @api_client.config.client_side_validation && namespace.nil?
        fail ArgumentError, "Missing the required parameter 'namespace' when calling PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi.read"
      end
      # verify the required parameter 'version' is set
      if @api_client.config.client_side_validation && version.nil?
        fail ArgumentError, "Missing the required parameter 'version' when calling PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi.read"
      end
      # resource path
      local_var_path = '/pulp_ansible/galaxy/default/api/v3/plugin/ansible/content/{distro_base_path}/collections/index/{namespace}/{name}/versions/{version}/'.sub('{' + 'distro_base_path' + '}', CGI.escape(distro_base_path.to_s).gsub('%2F', '/')).sub('{' + 'name' + '}', CGI.escape(name.to_s).gsub('%2F', '/')).sub('{' + 'namespace' + '}', CGI.escape(namespace.to_s).gsub('%2F', '/')).sub('{' + 'version' + '}', CGI.escape(version.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'CollectionVersionResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpAnsibleDefaultApiV3PluginAnsibleContentCollectionsIndexVersionsApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
